#ifndef TERRAIN_H
#define TERRAIN_H

#define MAX_MONSTRE 50

#define BAS 0
#define HAUT 1
#define GAUCHE 2
#define DROITE 3


class Terrain
{
    public:

        Terrain();
        void afficher(int X,int Y);
        int getTailleX();
        int getTailleY();
        int collision(int X,int Y);
        int collisionExplosion(int X,int Y);
        void bombeExplosion(int bombeX,int bombeY,int puissance,int percant);
        void frame();
        int bonus(int X,int Y);
        int collisionMonstre(int X,int Y);
        void load(int niveau);
        bool finNiveau();
        void loadRandom(int niveau);

    private:

        unsigned char l_blocs[2][24];
        unsigned char d_blocs[2][24];

        unsigned char l_explosions[9][24];
        unsigned char d_explosions[9][24];

        unsigned char l_bonus[5][24];
        unsigned char d_bonus[5][24];

        unsigned char d_momie[4][3][32];
        unsigned char l_momie[4][3][32];
        unsigned char momie_masque[4][3][30];

        unsigned char d_flamme[4][3][32];
        unsigned char l_flamme[4][3][32];
        unsigned char flamme_masque[4][3][32];

        unsigned char d_cracheur[4][3][32];
        unsigned char l_cracheur[4][3][32];
        unsigned char cracheur_masque[4][3][32];

        unsigned char map[625];
        unsigned char mapTime[625];
        unsigned char tailleX;
        unsigned char tailleY;
        unsigned char nombreMonstre;
        char monstreAnimation;
        int monstreX[MAX_MONSTRE];
        int monstreY[MAX_MONSTRE];
        char monstreType[MAX_MONSTRE];

        char monstreDirection[MAX_MONSTRE];
};

Terrain* getTerrain();
#endif // TERRAIN_H
