#include "usefull.h"
#include "fxlib.h"
#include "font.h"
#include "gray.h"
#include "draw.h"
#define SCA 0xD201D002
#define SCB 0x422B0009
#define SCE 0x80010070

typedef int(*sc_i2cp2sip) (char*, char*, short int*, short int*);
typedef int(*sc_iv) (void);
typedef int(*sc_4i) (int, int, int);

const unsigned int sc003b[] = {SCA, SCB, SCE, 0x3B};
const unsigned int sc0015[] = {SCA, SCB, SCE, 0x15};
const unsigned int sc0248[] = {SCA, SCB, SCE, 0x248};

#define RTC_GetTicks (*(sc_iv)sc003b)
#define PutKey (*(sc_4i)sc0248)
#define GlibGetOSVersionInfo (*(sc_i2cp2sip)sc0015)

int OSVersionAsInt(void)
{
	unsigned char mainversion;
	unsigned char minorversion;
	unsigned short release;
	unsigned short build;
	GlibGetOSVersionInfo( &mainversion, &minorversion, &release, &build );
	return ( ( mainversion << 24 ) & 0xFF000000 ) | ( ( minorversion << 16 ) & 0x00FF0000 ) | ( release & 0x0000FFFF );
}
#define isOS2 (OSVersionAsInt() >= 0x02020000)
#define OS2(x,y) ((OSVersionAsInt() >= 0x02020000)?y:x)
static int SysCallCode[] = {0xD201422B,0x60F20000,0x80010070};
static int (*SysCall)( int R4, int R5, int R6, int R7, int FNo ) = (void*)&SysCallCode;

void key_inject1(int keycode)
{
	(*SysCall)(keycode, 0, 0, 0, 0x248);
}


int time_getTicks()
{
	return RTC_GetTicks();
}

int getFps()
{
static unsigned int fps = 0, fps_count = 0, time = 0;

if( time_getTicks() - time >= 128)
		{
			fps = fps_count;
			fps_count = 1;
			time = time_getTicks();
		} else fps_count++;

return fps;
}
/*
int abs(int nombre)
{
    if(nombre < 0) return -nombre;
    return nombre;
}*/

void key_inject(int keycode)
{
	PutKey(-1, -1, keycode);
}

static void delay()
{
	unsigned char i;
	for(i=0 ; i<5 ; i++);
}

unsigned char CheckKeyRow(unsigned char code)
{
	unsigned char result=0;
	short*PORTB_CTRL=(void*)0xA4000102;
	short*PORTM_CTRL=(void*)0xA4000118;
	char*PORTB=(void*)0xA4000122;
	char*PORTM=(void*)0xA4000138;
	char*PORTA=(void*)0xA4000120;
	short smask;
	char cmask;
	unsigned char column, row;

	column = code>>4;
	row = code &0x0F;

	smask = 0x0003 << (( row %8)*2);
	cmask = ~( 1 << ( row %8) );
	if(row <8)
	{
		*PORTB_CTRL = 0xAAAA ^ smask;
		*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
		delay();
		*PORTB = cmask;
		*PORTM = (*PORTM & 0xF0 ) | 0x0F;
	}
	else
	{
		*PORTB_CTRL = 0xAAAA;
		*PORTM_CTRL = ((*PORTM_CTRL & 0xFF00 ) | 0x00AA)  ^ smask;
		delay();
		*PORTB = 0xFF;
		*PORTM = (*PORTM & 0xF0 ) | cmask;
	}
	delay();
	result = (~(*PORTA))>>column & 1;
	delay();
	*PORTB_CTRL = 0xAAAA;
	*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
	delay();
	*PORTB_CTRL = 0x5555;
	*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x0055;
	delay();



	return result;
}



unsigned char key_down_real(unsigned char code)
{
	unsigned short key[8];
	const unsigned short* keyboardregister = (unsigned short*)0xA44B0000;
	unsigned char row;

	if(isOS2)
        {
		memcpy(&key, keyboardregister, sizeof(unsigned short) << 3);
		row= code%10;
		return (0 != (key[row >> 1] & 1 << code / 10 - 1 + ((row & 1) << 3)));
        }
	else
        {
        return CheckKeyRow((code % 10) + ((code / 10 - 1) << 4));
        }
}




void pause()
{
int a;
char* screen = gray_getScreen()->VRAM1;
char* screen2 = gray_getScreen()->VRAM2;

for(a = 0;a<1024;a++)screen[a]= 255^screen[a];
for(a = 0;a<1024;a++)screen2[a]= 255^screen2[a];
gray_swapBuffers(0);
gray_clearVRAM();

while(!key_down_real(K_EXE)&&!key_down_real(K_SHIFT))
    if(key_down_real(K_EXIT) || key_down_real(K_MENU))reset_calc();
while(key_down_real(K_EXE)||key_down_real(K_SHIFT));
}

/*
int* getTimeTransition()
{
static int timeTransition= 0;
return &timeTransition;
}

void transition()
{
(*getTimeTransition())++;

ML_rectangle(0,0,128,*getTimeTransition(),0,ML_BLACK,ML_BLACK);
Bdisp_PutDisp_DD();
ML_clear_vram();
}
*/


unsigned char key_down(unsigned char code)
{
unsigned int keyT;
if(key_down_real(K_F1))pause();
if(code == K_EXE)return key_down_real(K_EXE) || key_down_real(K_SHIFT);
if(code == K_PMINUS)return key_down_real(K_PMINUS) || key_down_real(K_ALPHA);
if(code == K_MENU)return key_down_real(K_MENU) || key_down_real(K_EXIT);
return key_down_real(code);
}


int random(int max)
{
static unsigned int seed = 0x12345678;
if(max<1)seed=-max;
seed = (0x41C64E6D * seed) + 0x3039;
if(max>0)return ((seed >> 16) % max);

}


void PrintUnsigned(int X,int Y , unsigned int  variable)
{

    int i, length=0;
    char str[12] = "0";
    if(variable)
    {
        for(i=variable ; i ; i/=10) length++;
        str[length] = 0;
        for( ; variable ; variable/=10) str[--length] = variable%10+'0';
    }
    PrintStr(X,Y,str);
}


void PrintV(int X,int Y , int  variable)
{

    int i, length=0;
    char str[12] = "0";
    if(variable)
    {
        if(variable<0)
        {
            length++;
            str[0] = '-';
            variable = -variable;
        }
        for(i=variable ; i ; i/=10) length++;
        str[length] = 0;
        for( ; variable ; variable/=10) str[--length] = variable%10+'0';
    }
    PrintStr(X,Y,str);
}

void setFps(int fpsWish)
{
static unsigned int fps = 0, fps_count = 0;

do
{
fps = time_getTicks();
}
while(fps < fps_count+fpsWish);
fps_count = time_getTicks();

}



/*
char* inputString(char* message,int tailleMax)
{
int a;
int endroit = 0;
int curseurX = 0;
int curseurY = 0;
int ecran=0;
int wich;
int touche[]={K_XT,K_LOG,K_LN,K_SIN,K_COS,K_TAN,K_FRAC,K_FD,K_LPAR,K_RPAR,K_COMMA,K_STORE,K_7,K_8,K_9,K_4,K_5,K_6,K_MULT,K_DIV,K_1,K_2,K_3,K_PLUS,K_MINUS,K_0,K_DP};
int touche2[]={K_1,K_2,K_3,K_DP,K_COMMA,0,0,0,0,K_4,K_5,K_6,K_PLUS,K_MINUS,K_MULT,K_DIV,0,0,K_7,K_8,K_9,K_0,K_POW,K_LPAR,K_RPAR,0,0};
unsigned char fleche[] = {0xC0, 0xE0, 0xF0, 0xE0, 0xC0};
char texte[3][27]={"abcdefghijklmnopqrstuvwxyz ","ABCDEFGHIJKLMNOPQRSTUVWXYZ ","123.,;:!?456+-/'|7890^()\\ "};
char mot[40]={0};
for(a = 0;a<tailleMax;a++)mot[a]='_';
while(key_down(K_EXE))Sleep(5);
while(1)
    {
    if(key_down(K_UP) && curseurY)curseurY--;
    if(key_down(K_DOWN) && curseurY<2)curseurY++;
    if(key_down(K_LEFT) && curseurX)curseurX--;
    if(key_down(K_RIGHT) && curseurX<9)curseurX++;
    if(key_down(K_ALPHA)){if(ecran == 0)ecran = 1;else ecran =0;while(key_down(K_ALPHA))Sleep(5);}
    if(key_down(K_SHIFT)){if(ecran == 0)ecran = 2;else ecran =0;while(key_down(K_SHIFT))Sleep(5);}
    if(key_down_real(K_PMINUS) || key_down(K_DEL))
        {
        if(endroit)
            {
            endroit--;
            mot[endroit]='_';
            }
        while(key_down(K_DEL) || key_down_real(K_PMINUS))Sleep(5);
        }
    if(key_down_real(K_EXE))
        {
        if(curseurX==9)
            {
            if(curseurY == 0)if(ecran == 0)ecran = 1; else ecran = 0;
            if(curseurY == 1)if(ecran == 0)ecran = 2; else ecran = 0;
            if(curseurY == 2)
                {
                for(a = endroit;a<tailleMax;a++)if(mot[a]=='_')mot[a]=' ';
                return mot;
                }
            }
        else
            {
            if(ecran == 0 && curseurX == 8 && curseurY == 2)
                {
                if(endroit)
                    {
                    endroit--;
                    mot[endroit]='_';
                    }
                }
            else if(endroit<tailleMax)
                {
                mot[endroit]=texte[ecran][curseurX+curseurY*9];
                endroit++;
                }
            }
        while(key_down_real(K_EXE))Sleep(5);
        }

    if(ecran<2)
        {
        for(a=0;a<27;a++)if(key_down(touche[a]) && endroit<tailleMax){mot[endroit]=texte[ecran][a];endroit++;while(key_down(touche[a]))Sleep(5);}
        }
    else for(a=0;a<27;a++)if(key_down(touche2[a]) && endroit<tailleMax){mot[endroit]=texte[ecran][a];endroit++;while(key_down(touche2[a]))Sleep(5);}
    afficheFenetre(11);
    afficheFenetre(12);
    PrintStr(10,6,message);
    PrintStr(10,12,mot);
/*
    PrintStr(8,30,"1 2 3 4 5 6 7 8 9");
    PrintStr(8,39,"a b c d e f g i j k l m ");
    PrintStr(8,48,"n o p q r s t u v w x y z");

    PrintStr(100,48,"fin");
    PrintStr(100,30,"maj");
    PrintStr(100,39,"num");
    for(a =0;a<26;a++)PrintCharXY(10+(a%9)*10,30+9*(a>8)+9*(a>17),texte[ecran][a]);
    if(ecran == 0)
        {
        ML_line(90,50,94,50,ML_BLACK);
        ML_line(90,50,92,48,ML_BLACK);
        ML_line(90,50,92,52,ML_BLACK);
        }
    ML_bmp_or(fleche,curseurX*10+5,curseurY*9+30,5,5);
    ML_display_vram();
    ML_clear_vram();
    Sleep(150);
    }

}
*/
/*


int getAnimation(int change)
{
static int animation = 1;
if(change)animation = change-1;
return animation;
}


int getVitesseDialogue(int change)
{
static int vitesse = 2;
if(change)vitesse = change;
return vitesse;
}

int getFenetre(int change)
{
static int  fenetre = 1;
if(change)fenetre = change;
return fenetre;
}

*/
int inputChiffre()
{
int a;
char key[10]={K_0,K_1,K_2,K_3,K_4,K_5,K_6,K_7,K_8,K_9};
for(a=0;a<10;a++)if(key_down(key[a])){while(key_down(key[a]))Sleep(5);return a;}
return -1;
}

int max(int a,int b)
{
if(a < b)return b;
return a;
}




/*
void options()
{
unsigned char temp[1024];

int curseurY=0;
int choix = 1;
unsigned char fleche[] = {0xC0, 0xE0, 0xF0, 0xE0, 0xC0};
SaveDisp(SAVEDISP_PAGE3);
Bdisp_GetDisp_VRAM(temp);
ML_clear_vram();
//while(key_down_real(K_EXE) || key_down_real(K_SHIFT))Sleep(5);
while(1)
    {
    if(key_down_real(K_LEFT) && choix)choix--;
    if(key_down_real(K_RIGHT) && choix < 5)choix++;
    if((key_down_real(K_EXE) || key_down_real(K_SHIFT)) || key_down_real(K_DOWN))
        {
        curseurY++;
        while((key_down_real(K_EXE) || key_down_real(K_SHIFT)) || key_down_real(K_DOWN))Sleep(5);
        }
    if((key_down_real(K_EXE) || key_down_real(K_SHIFT)) || key_down_real(K_UP) && curseurY)
        {
        curseurY--;
        while((key_down_real(K_EXE) || key_down_real(K_SHIFT)) || key_down_real(K_UP))Sleep(5);
        }
    if(curseurY == 0 && choix >2)choix = 2;
    if(curseurY == 1 && choix >1)choix = 1;
    afficheFenetre(5);
    PrintStr(8,8,"vitesse des dialogues :");
    PrintStr(13,16,"lent      moyen     rapide");
    PrintStr(8,24,"animations :");
    PrintStr(13,32,"avec      sans");
    PrintStr(8,40,"type de fenetre");
    PrintStr(13,48,"1  2  3  4  5  6");
    if(curseurY == 3)break;

    if(curseurY == 0)getVitesseDialogue(1+choix);
    if(curseurY == 1)getAnimation(2-choix);
    if(curseurY == 2)getFenetre(choix+1);

    if(curseurY != 0)PrintCharXY(8+(getVitesseDialogue(0)-1)*40,16,'-');
    if(curseurY != 1)PrintCharXY(48-getAnimation(0)*40,32,'-');
    if(curseurY != 2)PrintCharXY(-4+getFenetre(0)*12,48,'-');

    if(curseurY<2)ML_bmp_or(fleche,8+choix*40,16+curseurY*16,5,5);
    else ML_bmp_or(fleche,8+choix*12,48,5,5);
    ML_display_vram();
    ML_clear_vram();
    Sleep(130);
    }
ML_clear_vram();
ML_bmp_or(temp,0,0,128,64);
RestoreDisp(SAVEDISP_PAGE3);
}
*/
